## actor-framework 0.18.0~rc1

=== debian/changelog ===
actor-framework (0.18.0~rc1-1) experimental; urgency=medium

  * New upstream version 0.18.0~rc1
  * Modernize debian/watch
  * Bump package name according to SONAME change
  * Drop/update patches
  * Update build rules. Doxygen documentation seems to have vanished 
    from upstream's build scripts, though.

 -- Hilko Bengen <bengen@debian.org>  Thu, 24 Dec 2020 02:37:18 +0100

=== debian/control ===
Source: actor-framework
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 12~),
 cmake,
 libssl-dev,
# ocl-icd-opencl-dev,
# python3-pybind11, pybind11-dev,
 libcurl4-openssl-dev,
 doxygen, pandoc, python3-pandocfilters, graphviz,
Standards-Version: 4.3.0
Section: libs
Homepage: http://www.actor-framework.org/

Package: libcaf-dev
Section: libdevel
Architecture: any
Depends: libcaf-core0.18 (= ${binary:Version}),
 libcaf-io0.18 (= ${binary:Version}),
 libcaf-openssl0.18 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libcaf-doc
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains headers and other files required to develop
 applications against the library.

Package: libcaf-core0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, core library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the core library.

Package: libcaf-io0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, I/O library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for network transparency.

Package: libcaf-openssl0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, OpenSSL library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for TLS encryption
 using OpenSSL.

Package: libcaf-doc
Section: doc
Architecture: all
Breaks: libcaf-dev (<< 0.16.3)
Replaces: libcaf-dev (<< 0.16.3)
Depends: ${misc:Depends}
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains documentation and examples for the library.

## actor-framework 0.18.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5...3.18 FATAL_ERROR)
project(CAF CXX)

# -- includes ------------------------------------------------------------------

include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(CheckCXXSourceCompiles)
include(GNUInstallDirs)
include(GenerateExportHeader)

# -- override CMake defaults for internal cache entries ------------------------

set(CMAKE_EXPORT_COMPILE_COMMANDS ON
    CACHE INTERNAL "Write JSON compile commands database")

# -- general options -----------------------------------------------------------

option(BUILD_SHARED_LIBS "Build shared library targets" ON)
option(THREADS_PREFER_PTHREAD_FLAG "Prefer -pthread flag if available " ON)

# -- CAF options that are off by default ---------------------------------------

option(CAF_ENABLE_CURL_EXAMPLES "Build examples with libcurl" OFF)
option(CAF_ENABLE_PROTOBUF_EXAMPLES "Build examples with Google Protobuf" OFF)
option(CAF_ENABLE_QT6_EXAMPLES "Build examples with the Qt6 framework" OFF)
option(CAF_ENABLE_RUNTIME_CHECKS "Build CAF with extra runtime assertions" OFF)
option(CAF_ENABLE_ACTOR_PROFILER "Enable experimental profiler API" OFF)

# -- CAF options that are on by default ----------------------------------------

option(CAF_ENABLE_EXAMPLES "Build small programs showcasing CAF features" ON)
option(CAF_ENABLE_IO_MODULE "Build networking I/O module" ON)
option(CAF_ENABLE_TESTING "Build unit test suites" ON)
option(CAF_ENABLE_TOOLS "Build utility programs such as caf-run" ON)
option(CAF_ENABLE_EXCEPTIONS "Build CAF with support for exceptions" ON)

# -- CAF options that depend on others -----------------------------------------

cmake_dependent_option(CAF_ENABLE_OPENSSL_MODULE "Build OpenSSL module" ON
                       "CAF_ENABLE_IO_MODULE" OFF)

# -- CAF options with non-boolean values ---------------------------------------

set(CAF_LOG_LEVEL "QUIET" CACHE STRING "Set log verbosity of CAF components")
set(CAF_SANITIZERS "" CACHE STRING
    "Comma separated sanitizers, e.g., 'address,undefined'")
set(CAF_BUILD_INFO_FILE_PATH "" CACHE FILEPATH
  "Optional path for writing CMake and compiler version information")

# -- macOS-specific options ----------------------------------------------------

if(APPLE)
  set(CMAKE_MACOSX_RPATH ON CACHE INTERNAL "Use rpaths on macOS and iOS")
endif()

# -- project-specific CMake settings -------------------------------------------

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# -- sanity checking -----------------------------------------------------------

if(CAF_ENABLE_OPENSSL_MODULE AND NOT CAF_ENABLE_IO_MODULE)
  message(FATAL_ERROR "Invalid options: cannot build OpenSSL without I/O")
endif()

set(CAF_VALID_LOG_LEVELS QUIET ERROR WARNING INFO DEBUG TRACE)
if(NOT CAF_LOG_LEVEL IN_LIST CAF_VALID_LOG_LEVELS)
  message(FATAL_ERROR "Invalid log level: \"${CAF_LOG_LEVEL}\"")
endif()

if(MSVC AND CAF_SANITIZERS)
  message(FATAL_ERROR "Sanitizer builds are currently not supported on MSVC")
endif()

# -- base target setup ---------------------------------------------------------

# This target propagates compiler flags, extra dependencies, etc. All other CAF
# targets pull this target in as a PRIVATE dependency. Users that embed CAF into
# their own CMake scaffold (e.g., via FetchContent) may pass this target in with
# some properties predefined in order to force compiler flags or dependencies.
if(NOT TARGET caf_internal)
  add_library(caf_internal INTERFACE)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  target_compile_options(caf_internal INTERFACE -Wall -Wextra -pedantic
                         -ftemplate-depth=512 -ftemplate-backtrace-limit=0)
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(caf_internal INTERFACE -Wdocumentation)
  else()
    target_compile_options(caf_internal INTERFACE
                           -Wno-missing-field-initializers)
  endif()
elseif(MSVC)
  target_compile_options(caf_internal INTERFACE /EHsc)
endif()

# -- unit testing setup / caf_add_test_suites function  ------------------------

if(CAF_ENABLE_TESTING)
  enable_testing()
  function(caf_add_test_suites target)
    foreach(suiteName ${ARGN})
      string(REPLACE "." "/" suitePath ${suiteName})
      target_sources(${target} PRIVATE
        "${CMAKE_CURRENT_SOURCE_DIR}/test/${suitePath}.cpp")
      add_test(NAME ${suiteName}
               COMMAND ${target} -r300 -n -v5 -s "^${suiteName}$")
    endforeach()
  endfunction()
endif()

# -- make sure we have at least C++17 available --------------------------------

# TODO: simply set CXX_STANDARD when switching to CMake ≥ 3.9.6
if(NOT CMAKE_CROSSCOMPILING)
  try_compile(caf_has_cxx_17
              "${CMAKE_CURRENT_BINARY_DIR}"
              "${CMAKE_CURRENT_SOURCE_DIR}/cmake/check-compiler-features.cpp")
  if(NOT caf_has_cxx_17)
    if(MSVC)
      set(cxx_flag "/std:c++17")
    else()
      if(CMAKE_CXX_COMPILER_ID MATCHES "Clang"
         AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
        set(cxx_flag "-std=c++1z")
      else()
        set(cxx_flag "-std=c++17")
      endif()
    endif()
    # Re-run compiler check.
    try_compile(caf_has_cxx_17
                "${CMAKE_CURRENT_BINARY_DIR}"
                "${CMAKE_CURRENT_SOURCE_DIR}/cmake/check-compiler-features.cpp"
                COMPILE_DEFINITIONS "${cxx_flag}"
                OUTPUT_VARIABLE cxx_check_output)
    if(NOT caf_has_cxx_17)
      message(FATAL_ERROR "\nFatal error: unable activate C++17 mode!\
                           \nPlease see README.md for supported compilers.\
                           \n\ntry_compile output:\n${cxx_check_output}")
    endif()
    target_compile_options(caf_internal INTERFACE "${cxx_flag}")
  endif()
endif()

# -- export internal target (may be useful for re-using compiler flags) --------

set_target_properties(caf_internal PROPERTIES EXPORT_NAME internal)

add_library(CAF::internal ALIAS caf_internal)

install(TARGETS caf_internal EXPORT CAFTargets)

# -- get CAF version -----------------------------------------------------------

# Get line containing the version from config.hpp and extract version number.
file(READ "libcaf_core/caf/config.hpp" CAF_CONFIG_HPP)
string(REGEX MATCH "#define CAF_VERSION [0-9]+" CAF_VERSION_LINE "${CAF_CONFIG_HPP}")
string(REGEX MATCH "[0-9]+" CAF_VERSION_INT "${CAF_VERSION_LINE}")
# Calculate major, minor, and patch version.
math(EXPR CAF_VERSION_MAJOR "${CAF_VERSION_INT} / 10000")
math(EXPR CAF_VERSION_MINOR "( ${CAF_VERSION_INT} / 100) % 100")
math(EXPR CAF_VERSION_PATCH "${CAF_VERSION_INT} % 100")
# Create full version string.
set(CAF_VERSION "${CAF_VERSION_MAJOR}.${CAF_VERSION_MINOR}.${CAF_VERSION_PATCH}"
  CACHE INTERNAL "The full CAF version string")
# Set the library version for our shared library targets.
if(CMAKE_HOST_SYSTEM_NAME MATCHES "OpenBSD")
  set(CAF_LIB_VERSION "${CAF_VERSION_MAJOR}.${CAF_VERSION_MINOR}"
      CACHE INTERNAL "The version string used for shared library objects")
else()
  set(CAF_LIB_VERSION "${CAF_VERSION}"
      CACHE INTERNAL "The version string used for shared library objects")
endif()

# -- install testing DSL headers -----------------------------------------------

add_library(libcaf_test INTERFACE)

set_target_properties(libcaf_test PROPERTIES EXPORT_NAME test)

target_include_directories(libcaf_test INTERFACE
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/libcaf_test>)

add_library(CAF::test ALIAS libcaf_test)

install(DIRECTORY libcaf_test/caf/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/caf
        FILES_MATCHING PATTERN "*.hpp")

install(TARGETS libcaf_test
        EXPORT CAFTargets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT test
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT test
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT test)

# -- add uninstall target if it does not exist yet -----------------------------

if(NOT TARGET uninstall)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake"
                 IMMEDIATE @ONLY)
  add_custom_target(
    uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake)
endif()

# -- utility functions ---------------------------------------------------------

# generates the implementation file for the enum that contains to_string,
# from_string and from_integer
function(caf_add_enum_type target enum_name)
  string(REPLACE "." "/" path "${enum_name}")
  set(hpp_file "${CMAKE_CURRENT_SOURCE_DIR}/caf/${path}.hpp")
  set(cpp_file "${CMAKE_CURRENT_BINARY_DIR}/src/${path}_strings.cpp")
  set(gen_file "${PROJECT_SOURCE_DIR}/cmake/caf-generate-enum-strings.cmake")
  add_custom_command(OUTPUT "${cpp_file}"
                     COMMAND ${CMAKE_COMMAND}
                       "-DINPUT_FILE=${hpp_file}"
                       "-DOUTPUT_FILE=${cpp_file}"
                       -P "${gen_file}"
                     DEPENDS "${hpp_file}" "${gen_file}")
  target_sources(${target} PRIVATE "${cpp_file}")
endfunction()

function(caf_export_and_install_lib component)
  add_library(CAF::${component} ALIAS libcaf_${component})
  string(TOUPPER "CAF_${component}_EXPORT" export_macro_name)
  target_include_directories(libcaf_${component} INTERFACE
                             $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                             $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
                             $<INSTALL_INTERFACE:include>)
  generate_export_header(
    libcaf_${component}
    EXPORT_MACRO_NAME ${export_macro_name}
    EXPORT_FILE_NAME "caf/detail/${component}_export.hpp")
  set_target_properties(libcaf_${component} PROPERTIES
                        EXPORT_NAME ${component}
                        SOVERSION ${CAF_VERSION}
                        VERSION ${CAF_LIB_VERSION}
                        OUTPUT_NAME caf_${component})
  install(TARGETS libcaf_${component}
          EXPORT CAFTargets
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT ${component}
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT ${component}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT ${component})
  install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/caf"
          DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
          COMPONENT ${component}
          FILES_MATCHING PATTERN "*.hpp")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/caf/detail/${component}_export.hpp"
          DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/caf/detail/")
endfunction()

# TODO: remove when switching to CMake > 3.12
function(caf_target_link_libraries target)
  if(CMAKE_VERSION VERSION_LESS 3.12)
    get_target_property(target_type ${target} TYPE)
    if (NOT target_type STREQUAL OBJECT_LIBRARY)
      target_link_libraries(${target} ${ARGN})
    else()
      cmake_parse_arguments(CAF_TARGET_LINK_LIBRARIES "" ""
                            "PUBLIC;PRIVATE;INTERFACE" ${ARGN})
      # If we can't link against it, at least make sure to pull in include paths
      # and compiler options.
      foreach(arg IN LISTS CAF_TARGET_LINK_LIBRARIES_PUBLIC
                           CAF_TARGET_LINK_LIBRARIES_PRIVATE)
        if (TARGET ${arg})
          target_include_directories(
            ${target} PRIVATE
            $<TARGET_PROPERTY:${arg},INTERFACE_INCLUDE_DIRECTORIES>)
          target_compile_options(
            ${target} PRIVATE
            $<TARGET_PROPERTY:${arg},INTERFACE_COMPILE_OPTIONS>)
        endif()
      endforeach()
    endif()
  else()
    target_link_libraries(${target} ${ARGN})
  endif()
endfunction()

# -- convenience function for automating our component setup -------------------

# Usage:
# caf_add_component(
#   foo
#   DEPENDENCIES
#     INTERFACE
#       ...
#     PUBLIC
#       ...
#     PRIVATE
#       ...
#   HEADERS
#     ...
#   SOURCES
#     ...
#   TEST_SOURCES
#     ...
#   TEST_SUITES
#     ...
# )
function(caf_add_component name)

=== examples/CMakeLists.txt ===
add_custom_target(all_examples)

function(add_example folder name)
  add_executable(${name} ${folder}/${name}.cpp ${ARGN})
  install(FILES ${folder}/${name}.cpp
          DESTINATION ${CMAKE_INSTALL_DATADIR}/caf/examples/${folder})
  add_dependencies(${name} all_examples)
endfunction()

function(add_core_example folder name)
  add_example(${folder} ${name} ${ARGN})
  target_link_libraries(${name} PRIVATE CAF::internal CAF::core)
endfunction()

# -- examples for CAF::core ----------------------------------------------------

# introductionary applications
add_core_example(. aout)
add_core_example(. hello_world)

# configuration API
add_core_example(config read-json)

# basic message passing primitives
add_core_example(message_passing calculator)
add_core_example(message_passing cell)
add_core_example(message_passing dancing_kirby)
add_core_example(message_passing delegating)
add_core_example(message_passing divider)
add_core_example(message_passing fan_out_request)
add_core_example(message_passing fixed_stack)
add_core_example(message_passing promises)
add_core_example(message_passing request)
add_core_example(message_passing typed_calculator)

# streaming API
add_core_example(streaming integer_stream)

# dynamic behavior changes using 'become'
add_core_example(dynamic_behavior skip_messages)
add_core_example(dynamic_behavior dining_philosophers)

# adding custom message types
add_core_example(custom_type custom_types_1)
add_core_example(custom_type custom_types_2)
add_core_example(custom_type custom_types_3)
add_core_example(custom_type custom_types_4)

# testing DSL
add_example(testing ping_pong)
target_link_libraries(ping_pong PRIVATE CAF::internal CAF::core CAF::test)
add_test(NAME "examples.ping-pong" COMMAND ping_pong -r300 -n -v5)

# -- examples for CAF::io ------------------------------------------------------

if(TARGET CAF::io)

  function(add_io_example folder name)
    add_example(${folder} ${name} ${ARGN})
    target_link_libraries(${name} PRIVATE CAF::internal CAF::io)
  endfunction()

  # basic remoting
  add_io_example(remoting group_chat)
  add_io_example(remoting group_server)
  add_io_example(remoting remote_spawn)
  add_io_example(remoting distributed_calculator)

  # basic I/O with brokers
  add_io_example(broker simple_broker)
  add_io_example(broker simple_http_broker)

  if(CAF_ENABLE_PROTOBUF_EXAMPLES)
    find_package(Protobuf REQUIRED)
    if(NOT PROTOBUF_PROTOC_EXECUTABLE)
      message(FATAL_ERROR "CMake was unable to set PROTOBUF_PROTOC_EXECUTABLE")
    endif()
    protobuf_generate_cpp(ProtoSources ProtoHeaders "${CMAKE_CURRENT_SOURCE_DIR}/remoting/pingpong.proto")
    include_directories(${PROTOBUF_INCLUDE_DIR})
    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    add_executable(protobuf_broker broker/protobuf_broker.cpp ${ProtoSources})
    target_link_libraries(protobuf_broker
                          PRIVATE ${PROTOBUF_LIBRARIES} CAF::internal CAF::io)
    add_dependencies(protobuf_broker all_examples)
  endif()

  if(CAF_ENABLE_QT6_EXAMPLES)
    find_package(Qt6 COMPONENTS Core Gui Widgets REQUIRED)
    qt6_wrap_ui(GROUP_CHAT_UI_HDR qtsupport/chatwindow.ui)
    qt6_wrap_cpp(GROUP_CHAT_MOC_SRC qtsupport/chatwidget.hpp)
    # generated headers will be in cmake build directory
    add_executable(qt_group_chat
                   qtsupport/qt_group_chat.cpp
                   qtsupport/chatwidget.cpp
                   ${GROUP_CHAT_MOC_SRC}
                   ${GROUP_CHAT_UI_HDR})
    target_link_libraries(qt_group_chat
                          CAF::io
                          CAF::internal
                          Qt6::Core
                          Qt6::Gui
                          Qt6::Widgets)
    target_include_directories(qt_group_chat PRIVATE
                               qtsupport
                               ${CMAKE_CURRENT_BINARY_DIR}
                               ${Qt6Core_INCLUDE_DIRS}
                               ${Qt6Gui_INCLUDE_DIRS}
                               ${Qt6Widgets_INCLUDE_DIRS})
    if (CMAKE_VERSION VERSION_LESS 3.8)
      message(STATUS "Note: build fails if Qt6 sets incompatible -std=ARG flag")
    else()
      set_property(TARGET qt_group_chat PROPERTY CXX_STANDARD 17)
    endif()
    add_dependencies(qt_group_chat all_examples)
  endif()

  if(CAF_ENABLE_CURL_EXAMPLES)
    find_package(CURL REQUIRED)
    add_executable(curl_fuse curl/curl_fuse.cpp)
    include_directories(${CURL_INCLUDE_DIRS})
    target_link_libraries(curl_fuse ${CURL_LIBRARY} CAF::io CAF::internal)
    add_dependencies(curl_fuse all_examples)
  endif()

endif()

=== libcaf_core/CMakeLists.txt ===
# -- collect header files ------------------------------------------------------

file(GLOB_RECURSE CAF_CORE_HEADERS "caf/*.hpp")

# -- dependencies --------------------------------------------------------------

if(NOT TARGET Threads::Threads)
  find_package(Threads REQUIRED)
endif()

set(LIBCAF_CORE_OPTIONAL_DEPENDENCIES "")

# Check whether we need to link against libatomic.
if(NOT CMAKE_CROSSCOMPILING)
  set(snippet "#include <cstdint>
               #include <atomic>
               std::atomic<uint64_t> x;
               int main(int, char**) { return static_cast<int>(x.load()); }")
  check_cxx_source_compiles("${snippet}" has_64bit_atomic)
  if(NOT has_64bit_atomic)
    set(required_libs_backup "${CMAKE_REQUIRED_LIBRARIES}")
    list(APPEND CMAKE_REQUIRED_LIBRARIES "atomic")
    check_cxx_source_compiles("${snippet}" has_64bit_atomic_with_libatomic)
    set(CMAKE_REQUIRED_LIBRARIES "${required_libs_backup}")
    if(NOT has_64bit_atomic_with_libatomic)
      message(FATAL_ERROR "Unable to compile code with std::atomic<uint64_t>")
    endif()
    list(APPEND LIBCAF_CORE_OPTIONAL_DEPENDENCIES atomic)
  endif()
endif()

if(MSVC)
    list(APPEND LIBCAF_CORE_OPTIONAL_DEPENDENCIES iphlpapi)
endif()

# -- generated files -----------------------------------------------------------

configure_file("${PROJECT_SOURCE_DIR}/cmake/build_config.hpp.in"
               "caf/detail/build_config.hpp"
               @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/caf/detail/build_config.hpp"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/caf/detail/")

# -- add targets ---------------------------------------------------------------

caf_add_component(
  core
  DEPENDENCIES
    PUBLIC
      Threads::Threads
      ${LIBCAF_CORE_OPTIONAL_DEPENDENCIES}
    PRIVATE
      CAF::internal
  ENUM_TYPES
    exit_reason
    intrusive.inbox_result
    intrusive.task_result
    invoke_message_result
    message_priority
    pec
    sec
    stream_priority
  HEADERS
    ${CAF_CORE_HEADERS}
  SOURCES
    src/abstract_actor.cpp
    src/abstract_channel.cpp
    src/abstract_group.cpp
    src/action.cpp
    src/actor.cpp
    src/actor_addr.cpp
    src/actor_clock.cpp
    src/actor_companion.cpp
    src/actor_config.cpp
    src/actor_control_block.cpp
    src/actor_ostream.cpp
    src/actor_pool.cpp
    src/actor_profiler.cpp
    src/actor_proxy.cpp
    src/actor_registry.cpp
    src/actor_system.cpp
    src/actor_system_config.cpp
    src/attachable.cpp
    src/behavior.cpp
    src/binary_deserializer.cpp
    src/binary_serializer.cpp
    src/blocking_actor.cpp
    src/config_option.cpp
    src/config_option_adder.cpp
    src/config_option_set.cpp
    src/config_value.cpp
    src/config_value_reader.cpp
    src/config_value_writer.cpp
    src/credit_controller.cpp
    src/decorator/sequencer.cpp
    src/default_attachable.cpp
    src/deserializer.cpp
    src/detail/abstract_worker.cpp
    src/detail/abstract_worker_hub.cpp
    src/detail/append_percent_encoded.cpp
    src/detail/base64.cpp
    src/detail/behavior_impl.cpp
    src/detail/behavior_stack.cpp
    src/detail/blocking_behavior.cpp
    src/detail/config_consumer.cpp
    src/detail/get_mac_addresses.cpp
    src/detail/get_process_id.cpp
    src/detail/get_root_uuid.cpp
    src/detail/glob_match.cpp
    src/detail/group_tunnel.cpp
    src/detail/invoke_result_visitor.cpp
    src/detail/json.cpp
    src/detail/latch.cpp
    src/detail/local_group_module.cpp
    src/detail/message_builder_element.cpp
    src/detail/message_data.cpp
    src/detail/meta_object.cpp
    src/detail/monotonic_buffer_resource.cpp
    src/detail/parse.cpp
    src/detail/parser/chars.cpp
    src/detail/pretty_type_name.cpp
    src/detail/print.cpp
    src/detail/private_thread.cpp
    src/detail/private_thread_pool.cpp
    src/detail/ripemd_160.cpp
    src/detail/serialized_size.cpp
    src/detail/set_thread_name.cpp
    src/detail/shared_spinlock.cpp
    src/detail/size_based_credit_controller.cpp
    src/detail/stringification_inspector.cpp
    src/detail/sync_request_bouncer.cpp
    src/detail/test_actor_clock.cpp
    src/detail/thread_safe_actor_clock.cpp
    src/detail/tick_emitter.cpp
    src/detail/token_based_credit_controller.cpp
    src/detail/type_id_list_builder.cpp
    src/disposable.cpp
    src/downstream_manager.cpp
    src/downstream_manager_base.cpp
    src/error.cpp
    src/event_based_actor.cpp
    src/execution_unit.cpp
    src/forwarding_actor_proxy.cpp
    src/group.cpp
    src/group_manager.cpp
    src/group_module.cpp
    src/hash/sha1.cpp
    src/inbound_path.cpp
    src/init_global_meta_objects.cpp
    src/ipv4_address.cpp
    src/ipv4_endpoint.cpp
    src/ipv4_subnet.cpp
    src/ipv6_address.cpp
    src/ipv6_endpoint.cpp
    src/ipv6_subnet.cpp
    src/json_reader.cpp
    src/json_writer.cpp
    src/load_inspector.cpp
    src/local_actor.cpp
    src/logger.cpp
    src/mailbox_element.cpp
    src/make_config_option.cpp
    src/message.cpp
    src/message_builder.cpp
    src/message_handler.cpp
    src/monitorable_actor.cpp
    src/node_id.cpp
    src/outbound_path.cpp
    src/policy/downstream_messages.cpp
    src/policy/unprofiled.cpp
    src/policy/work_sharing.cpp
    src/policy/work_stealing.cpp
    src/proxy_registry.cpp
    src/raise_error.cpp
    src/ref_counted.cpp
    src/replies_to.cpp
    src/response_promise.cpp
    src/resumable.cpp
    src/save_inspector.cpp
    src/scheduled_actor.cpp
    src/scheduler/abstract_coordinator.cpp
    src/scheduler/test_coordinator.cpp
    src/scoped_actor.cpp
    src/scoped_execution_unit.cpp
    src/serializer.cpp
    src/settings.cpp
    src/skip.cpp
    src/stream_aborter.cpp
    src/stream_manager.cpp
    src/string_algorithms.cpp
    src/string_view.cpp
    src/telemetry/collector/prometheus.cpp
    src/telemetry/importer/process.cpp
    src/telemetry/label.cpp
    src/telemetry/label_view.cpp
    src/telemetry/metric.cpp
    src/telemetry/metric_family.cpp
    src/telemetry/metric_registry.cpp
    src/term.cpp
    src/thread_hook.cpp
    src/timestamp.cpp
    src/tracing_data.cpp
    src/tracing_data_factory.cpp
    src/type_id.cpp
    src/type_id_list.cpp
    src/uri.cpp
    src/uri_builder.cpp
    src/uuid.cpp
  TEST_SOURCES
    test/core-test.cpp
    test/nasty.cpp
  TEST_SUITES
    action
    actor_clock
    actor_factory
    actor_lifetime
    actor_pool
    actor_profiler
    actor_registry
    actor_system_config
    actor_termination
    aout
    behavior
    binary_deserializer
    binary_serializer
    blocking_actor
    broadcast_downstream_manager
    byte
    composition
    config_option
    config_option_set
    config_value
    config_value_reader
    config_value_writer
    const_typed_message_view
    constructor_attach
    continuous_streaming
    cow_tuple
    decorator.sequencer
    deep_to_string
    detached_actors
    detail.base64
    detail.bounds_checker
    detail.config_consumer
    detail.group_tunnel
    detail.ieee_754
    detail.json
    detail.latch
    detail.limited_vector
    detail.local_group_module
    detail.meta_object
    detail.monotonic_buffer_resource
    detail.parse
    detail.parser.read_bool
    detail.parser.read_config
    detail.parser.read_floating_point
    detail.parser.read_number
    detail.parser.read_number_or_timespan
    detail.parser.read_signed_integer
    detail.parser.read_string
    detail.parser.read_timespan
    detail.parser.read_unsigned_integer
    detail.private_thread_pool
    detail.ringbuffer
    detail.ripemd_160
    detail.serialized_size
    detail.tick_emitter
    detail.type_id_list_builder
    detail.unique_function
    detail.unordered_flat_map
    dictionary
    dsl
    dynamic_spawn
    error
    expected
    function_view
    fused_downstream_manager
    handles
    hash.fnv
    hash.sha1
    intrusive.drr_cached_queue
    intrusive.drr_queue
    intrusive.fifo_inbox
    intrusive.lifo_inbox
    intrusive.task_queue
    intrusive.wdrr_dynamic_multiplexed_queue
    intrusive.wdrr_fixed_multiplexed_queue
    intrusive_ptr
    ipv4_address
    ipv4_endpoint
    ipv4_subnet
    ipv6_address
    ipv6_endpoint
    ipv6_subnet
    json_reader
    json_writer
    load_inspector
    logger
    mailbox_element
    message
    message_builder
    message_id
    message_lifetime
    metaprogramming
    mixin.requester
    mixin.sender
    mock_streaming_classes
    mtl
    native_streaming_classes
    node_id
    optional
    or_else
    pipeline_streaming
    policy.categorized
    policy.select_all
    policy.select_any
    request_timeout
    response_promise
    result
    save_inspector
    scheduled_actor
    selective_streaming
    serial_reply
    serialization
    settings
    simple_timeout
    span
    stateful_actor
    string_algorithms
    string_view
    sum_type
    telemetry.collector.prometheus
    telemetry.counter
    telemetry.gauge
    telemetry.histogram
    telemetry.label
    telemetry.metric_registry
    telemetry.timer
    thread_hook
    tracing_data
    type_id_list
    typed_behavior
    typed_message_view
    typed_response_promise
    typed_spawn
    unit
    uri
    uuid
    variant)

if(CAF_ENABLE_TESTING AND CAF_ENABLE_EXCEPTIONS)
  caf_add_test_suites(caf-core-test custom_exception_handler)
endif()

=== tools/CMakeLists.txt ===
add_custom_target(all_tools)

macro(add name)
  add_executable(${name} ${name}.cpp ${ARGN})
  install(TARGETS ${name} DESTINATION ${CMAKE_INSTALL_DATADIR}/caf/tools)
  add_dependencies(${name} all_tools)
endmacro()

add(caf-vec)
target_link_libraries(caf-vec PRIVATE CAF::internal CAF::core)

if(TARGET CAF::io)
  if(WIN32)
    message(STATUS "Skip caf-run (not supported on Windows)")
  else()
    add(caf-run)
    target_link_libraries(caf-run PRIVATE CAF::internal CAF::io)
  endif()
endif()

=== debian/changelog ===
actor-framework (0.18.7-1~exp1) experimental; urgency=medium

  * New upstream version 0.18.7
  * Add patch for missing include needed with newer GCC

 -- Hilko Bengen <bengen@debian.org>  Fri, 28 Jul 2023 20:51:47 +0200

actor-framework (0.18.6-1) experimental; urgency=medium

  * New upstream version 0.18.6
  * Add gbp.conf
  * Bump Standards-Version, Debhelper compat level
  * Update patches

 -- Hilko Bengen <bengen@debian.org>  Sun, 08 Jan 2023 14:11:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: actor-framework
 Priority: optional
 Maintainer: Hilko Bengen <bengen@debian.org>
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (=13),
  cmake,
  libssl-dev,
 # ocl-icd-opencl-dev,
 # python3-pybind11, pybind11-dev,
  libcurl4-openssl-dev,
  doxygen, pandoc, python3-pandocfilters, graphviz,
-Standards-Version: 4.3.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: http://www.actor-framework.org/

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libcaf-doc
	mv -t debian/tmp/usr/share/doc/libcaf-doc \
	      debian/tmp/usr/share/caf/*
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/actor-framework-$1\.tar\.gz/,\
  versionmangle=s/-rc[.]?/~rc/ \
  https://github.com/actor-framework/actor-framework/tags .*/v?(\d\S*)\.tar\.gz
